//
//  XWorkOrderSegment.swift
//
//
//  Created by Michiel Carman on 1/31/24.
//

import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlXWorkOrderSegment: Model, Content {
    static let schema = "xWorkOrderSegment"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    @Parent(key: "workOrderId") var workorder: mdlWorkOrder
    @Parent(key: "segmentId") var segment: mdlSegment
    
    //@Children(for: \.$segment) var parts: [mdlWorkOrderPart]
    
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init(){}
    
    init(id: Int? = nil, workorderid: Int, segmentid: Int, createdate: Date? = nil, createuserid: Int? = nil, updatedate: Date? = nil, updateuserid: Int? = nil) {
        self.id = id
        self.$workorder.$id.value = workorderid
        self.$segment.$id.value = segmentid
        self.createdate = createdate
        self.createuserid = createuserid
        self.updatedate = updatedate
        self.updateuserid = updateuserid
    }
    
}
extension mdlXWorkOrderSegment{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("xWorkOrderSegment")
                .field("id", .int, .identifier(auto: true))
                .field("workOrderId", .int, .references("workOrder", "id"))
                .field("segmentId", .int, .references("segment", "id"))
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }

        func revert(on database: Database) async throws {
            try await database.schema("user").delete()
        }
    }
    struct Delete: AsyncMigration {
        func revert(on database: Database) async throws {
            try await database.schema("xWorkOrderSegment")
                .field("id", .int, .identifier(auto: true))
                .field("workOrderId", .int, .references("workOrder", "id"))
                .field("segmentId", .int, .references("segment", "id"))
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }

        func prepare(on database: Database) async throws {
            try await database.schema("xWorkOrderSegment").delete()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlWorkOrderSegment>{
        
        let query = mdlWorkOrderSegment.query(on: req.db)
            .with(\.$workorder)
            .with(\.$segment)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}




